You can set different filters to get the data that you need.
The user can set a filter as follows:
You can use the Label Filter as follows:
You can use the Value Filter as follows:
SpreadJS PivotTable supports five conditions:
For date filter operator, we also support month to date and quarter to date.
conType: Used to describe the type of condition
operator: Used to describe the operate type of filter; setting up an operator corresponds to the type of conType
SpreadJS PivotTables support two filters, and users can set filters using the following two data types, for example:
window.onload = function () {
let spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 2 });
initSpread(spread);
};
function initSpread(spread) {
spread.suspendPaint();
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getSource(sheet2, pivotSales);
let pivotTable = addPivotTable(sheet1, tableName);
bindEvent(pivotTable,spread);
spread.resumePaint();
}
function getSource(sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
function addPivotTable(sheet, source) {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(10000);
let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("date", "Date", GC.Spread.Pivot.PivotTableFieldType.columnField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
function _isNullOrUndefined (obj) {
return obj === null || obj === undefined;
}
function bindEvent(pivotTable,spread) {
document.getElementById("set-label-filter").addEventListener("click", function (e) {
spread.suspendPaint();
let labelType, labelFilterValue1, labelFilterValue2;
let labelNode = document.getElementById("labelFilter");
labelType = labelNode.selectedIndex;
if (!_isNullOrUndefined(labelType)) {
labelFilterValue1 = document.getElementById("label-val1").value;
labelFilterValue2 = document.getElementById("label-val2").value;
if (labelType < 13) {
labelFilterValue2 = null;
}
pivotTable.labelFilter("Salesperson", { condition: { conType: GC.Pivot.PivotConditionType.caption, val: [labelFilterValue1, labelFilterValue2], operator: labelType} });
} else {
pivotTable.labelFilter("Salesperson", null);
}
spread.resumePaint();
});
document.getElementById("clear-label-filter").addEventListener("click", function (e) {
spread.suspendPaint();
pivotTable.labelFilter("Salesperson", null);
document.getElementById("labelFilter").selectedIndex = 0;
document.getElementById("label-val1").value = null;
document.getElementById("label-val2").value = null;
spread.resumePaint();
});
document.getElementById("clear-value-filter").addEventListener("click", function (e) {
spread.suspendPaint();
pivotTable.valueFilter("Salesperson", null);
document.getElementById("valueFilter").selectedIndex = 0;
document.getElementById("value-val1").value = null;
document.getElementById("value-val2").value = null;
spread.resumePaint();
});
document.getElementById("set-value-filter").addEventListener("click", function (e) {
spread.suspendPaint();
let valueType, valueFilterValue1, valueFilterValue2;
let valueNode = document.getElementById("valueFilter");
valueType = valueNode.selectedIndex;
if (!_isNullOrUndefined(valueType)) {
valueFilterValue1 = document.getElementById("value-val1").value;
valueFilterValue2 = document.getElementById("value-val2").value;
if (valueType < 7) {
valueFilterValue2 = null;
}
pivotTable.valueFilter("Salesperson", { condition: { conType: GC.Pivot.PivotConditionType.value, val: [valueFilterValue1, valueFilterValue2], operator: valueType }, conditionByName: "Quantity" });
} else {
pivotTable.valueFilter("Salesperson", null);
}
spread.resumePaint();
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="whole-field">The following operations all work on <b>Salesperson</b> Field:</div>
<div>Label Filter:</div>
<div class="pivottable-filter label-filter">
<select name="labelFilter" id="labelFilter" class="pivot-filter">
<option value="equalsTo" selected>equalsTo</option>
<option value="notEqualsTo">notEqualsTo</option>
<option value="beginsWith">beginsWith</option>
<option value="doesNotBeginWith">doesNotBeginWith</option>
<option value="endsWith">endsWith</option>
<option value="doesNotEndWith">doesNotEndWith</option>
<option value="contains">contains</option>
<option value="doesNotContain">doesNotContain</option>
<option value="greaterThan">greaterThan</option>
<option value="greaterThanOrEqualsTo">greaterThanOrEqualsTo</option>
<option value="lessThan">lessThan</option>
<option value="lessThanOrEqualsTo">lessThanOrEqualsTo</option>
<option value="between">between</option>
<option value="notBetween">notBetween</option>
</select>
<input type="text" class="label-filter-input filter-input" id="label-val1" placeholder = "value1">
<input type="text" class="label-filter-input filter-input" id="label-val2" placeholder = "value2">
</div>
<input type="button" class="set-label-filter set-filter" id="set-label-filter" value="Set Label Filter">
<br />
<input type="button" class="set-label-filter set-filter" id="clear-label-filter" value="Clear Label Filter">
<br />
<hr />
<div class="value-filter-label">Value Filter:</div>
<div class="pivottable-filter value-filter">
<select name="valueFilter" id="valueFilter" class="pivot-filter">
<option value="equalsTo" selected>equalsTo</option>
<option value="notEqualsTo">notEqualsTo</option>
<option value="greaterThan">greaterThan</option>
<option value="greaterThanOrEqualsTo">greaterThanOrEqualsTo</option>
<option value="lessThan">lessThan</option>
<option value="lessThanOrEqualsTo">lessThanOrEqualsTo</option>
<option value="between">between</option>
<option value="notBetween">notBetween</option>
</select>
<input type="text" class="value-filter-input filter-input" id="value-val1" placeholder = "value1">
<input type="text" class="value-filter-input filter-input" id="value-val2" placeholder = "value2">
</div>
<input type="button" class="set-value-filter set-filter" id="set-value-filter" value="Set Value Filter">
<br />
<input type="button" class="set-value-filter set-filter" id="clear-value-filter" value="Clear Value Filter"> <br />
<hr />
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.pivottable-filter{
height: 100px;
}
.pivot-filter{
width: 200px;
height: 25px;
display: block;
margin-bottom: 10px;
float: left;
}
.filter-input{
width: 200px;
height: 20px;
display: block;
/* margin-left: 15px; */
margin-top: 10px;
}
.set-filter{
width: 200px;
margin-top: 20px;
/* float: right; */
}
.value-filter-label{
margin-top: 25px;
}
.sort-type{
width: 200px;
margin-top: 25px;
display: block;
}
.sort{
width: 200px;
margin-top: 10px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.whole-field{
margin-bottom: 10px;
}

You can set different filters to get the data that you need.
The user can set a filter as follows:
You can use the Label Filter as follows:
You can use the Value Filter as follows:
SpreadJS PivotTable supports five conditions:
For date filter operator, we also support month to date and quarter to date.
conType: Used to describe the type of condition
operator: Used to describe the operate type of filter; setting up an operator corresponds to the type of conType
SpreadJS PivotTables support two filters, and users can set filters using the following two data types, for example:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import { FormsModule } from '@angular/forms';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
autoGenerateColumns = false;
autoMergeMode = GC.Spread.Sheets.AutoMerge.AutoMergeMode.restricted;
autoMergeSelectionMode = GC.Spread.Sheets.AutoMerge.SelectionMode.merged;
dataSource: any[];
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
pivotTable:any;
labelFilter = 1;
label1:string = "";
label2:string = "";
valueFilter = 1;
value1: number;
value2: number;
constructor() {
}
initSpread($Event: any) {
let spread = $Event.spread;
this.spread = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getSource(sheet2, pivotSales);
let pivotTable = this.addPivotTable(sheet1, tableName);
this.pivotTable = pivotTable;
spread.resumePaint();
}
getSource(sheet: GC.Spread.Sheets.Workbook, tableSource: any) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
clearLabelFilter () {
let spread = this.spread;
let pivotTable = this.pivotTable;
spread.suspendPaint();
this.label1 = "";
this.label2 = "";
this.labelFilter = 1;
pivotTable.labelFilter("Salesperson", null);
spread.resumePaint();
}
clearValueFilter () {
let spread = this.spread;
let pivotTable = this.pivotTable;
spread.suspendPaint();
this.value1 = null;
this.value2 = null;
this.valueFilter = 1;
pivotTable.valueFilter("Salesperson", null);
spread.resumePaint();
}
setLabelFilter () {
let spread = this.spread;
let pivotTable = this.pivotTable;
spread.suspendPaint();
let labelType = +this.labelFilter, labelFilterValue1 = this.label1, labelFilterValue2 = this.label2;
if (labelType) {
if (labelType < 13) {
labelFilterValue2 = null;
}
pivotTable.labelFilter("Salesperson", { condition: { conType: GC.Pivot.PivotConditionType.caption, val: [labelFilterValue1, labelFilterValue2], operator: labelType - 1 } });
} else {
pivotTable.labelFilter("Salesperson", null);
}
spread.resumePaint();
}
setValueFilter () {
let spread = this.spread;
let pivotTable = this.pivotTable;
spread.suspendPaint();
let valueType= +this.valueFilter, valueFilterValue1 = +this.value1, valueFilterValue2 = +this.value2;
if (valueType) {
if (valueType < 7) {
valueFilterValue2 = null;
}
pivotTable.valueFilter("Salesperson", { condition: { conType: GC.Pivot.PivotConditionType.value, val: [valueFilterValue1, valueFilterValue2], operator: valueType - 1 }, conditionByName: "Quantity" });
} else {
pivotTable.valueFilter("Salesperson", null);
}
spread.resumePaint();
}
addPivotTable(sheet: GC.Spread.Sheets.Workbook, source: any) {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(10000);
let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div class="whole-field">The following operations all work on <b>Salesperson</b> Field:</div>
<hr />
<div>Label Filter:</div>
<div class="pivottable-filter label-filter">
<select name="labelFilter" id="labelFilter" class="pivot-filter" [(ngModel)]="labelFilter">
<option value="1">equalsTo</option>
<option value="2">notEqualsTo</option>
<option value="3">beginsWith</option>
<option value="4">doesNotBeginWith</option>
<option value="5">endsWith</option>
<option value="6">doesNotEndWith</option>
<option value="7">contains</option>
<option value="8">doesNotContain</option>
<option value="9">greaterThan</option>
<option value="10">greaterThanOrEqualsTo</option>
<option value="11">lessThan</option>
<option value="12">lessThanOrEqualsTo</option>
<option value="13">between</option>
<option value="14">notBetween</option>
</select>
<input type="text" class="label-filter-input filter-input" id="label-val1" placeholder = "value1" [(ngModel)]="label1">
<input type="text" class="label-filter-input filter-input" id="label-val2" placeholder = "value2" [(ngModel)]="label2">
</div>
<input type="button" class="set-label-filter set-filter" id="set-label-filter" value="Set Label Filter" (click)="setLabelFilter()">
<br />
<input type="button" class="set-label-filter set-filter" id="clear-label-filter" value="Clear Label Filter" (click)="clearLabelFilter()">
<br />
<hr />
<div class="value-filter-label">Value Filter (Salesperson Grand Total):</div>
<div class="pivottable-filter value-filter">
<select name="valueFilter" id="valueFilter" class="pivot-filter" [(ngModel)]="valueFilter">
<option value="0">clearFilter</option>
<option value="1">equalsTo</option>
<option value="2">notEqualsTo</option>
<option value="3">greaterThan</option>
<option value="4">greaterThanOrEqualsTo</option>
<option value="5">lessThan</option>
<option value="6">lessThanOrEqualsTo</option>
<option value="7">between</option>
<option value="8">notBetween</option>
</select>
<input type="text" class="value-filter-input filter-input" id="value-val1" placeholder = "value1" [(ngModel)]="value1">
<input type="text" class="value-filter-input filter-input" id="value-val2" placeholder = "value2" [(ngModel)]="value2">
</div>
<input type="button" class="set-value-filter set-filter" id="set-value-filter" value="Set Value Filter" (click)="setValueFilter()">
<br />
<input type="button" class="set-value-filter set-filter" id="clear-value-filter" value="Clear Value Filter" (click)="clearValueFilter()">
<br />
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.pivottable-filter{
height: 100px;
}
.pivot-filter{
width: 200px;
height: 25px;
display: block;
margin-bottom: 10px;
float: left;
}
.filter-input{
width: 200px;
height: 20px;
display: block;
/* margin-left: 15px; */
margin-top: 10px;
}
.set-filter{
width: 200px;
margin-top: 20px;
/* float: right; */
}
.value-filter-label{
margin-top: 25px;
}
.sort-type{
width: 200px;
margin-top: 25px;
display: block;
}
.sort{
width: 200px;
margin-top: 10px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.whole-field{
margin-bottom: 10px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

You can set different filters to get the data that you need.
The user can set a filter as follows:
You can use the Label Filter as follows:
You can use the Value Filter as follows:
SpreadJS PivotTable supports five conditions:
For date filter operator, we also support month to date and quarter to date.
conType: Used to describe the type of condition
operator: Used to describe the operate type of filter; setting up an operator corresponds to the type of conType
SpreadJS PivotTables support two filters, and users can set filters using the following two data types, for example:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<div class="whole-field">The following operations all work on <b>Salesperson</b> Field:</div>
<div>Label Filter:</div>
<div class="pivottable-filter label-filter">
<select name="labelFilter" id="labelFilter" class="pivot-filter" v-model="labelFilterRef">
<option value=1>equalsTo</option>
<option value=2>notEqualsTo</option>
<option value=3>beginsWith</option>
<option value=4>doesNotBeginWith</option>
<option value=5>endsWith</option>
<option value=6>doesNotEndWith</option>
<option value=7>contains</option>
<option value=8>doesNotContain</option>
<option value=9>greaterThan</option>
<option value=10>greaterThanOrEqualsTo</option>
<option value=11>lessThan</option>
<option value=12>lessThanOrEqualsTo</option>
<option value=13>between</option>
<option value=14>notBetween</option>
</select>
<input type="text" class="label-filter-input filter-input" id="label-val1" placeholder="value1"
v-model="label1Ref" />
<input type="text" class="label-filter-input filter-input" id="label-val2" placeholder="value2"
v-model="label2Ref" />
</div>
<input type="button" class="set-label-filter set-filter" id="set-label-filter" value="Set Label Filter"
@click="updatePivotLabelFilter" />
<br />
<input type="button" class="set-label-filter set-filter" id="clear-label-filter" value="Clear Label Filter"
@click="clearPivotLabelFilter" />
<br />
<hr />
<div class="value-filter-label">Value Filter:</div>
<div class="pivottable-filter value-filter">
<select name="valueFilter" id="valueFilter" class="pivot-filter" v-model="valueFilterRef">
<option value=1>equalsTo</option>
<option value=2>notEqualsTo</option>
<option value=3>greaterThan</option>
<option value=4>greaterThanOrEqualsTo</option>
<option value=5>lessThan</option>
<option value=6>lessThanOrEqualsTo</option>
<option value=7>between</option>
<option value=8>notBetween</option>
</select>
<input type="text" class="value-filter-input filter-input" id="value-val1" placeholder="value1"
v-model="value1Ref" />
<input type="text" class="value-filter-input filter-input" id="value-val2" placeholder="value2"
v-model="value2Ref" />
</div>
<input type="button" class="set-value-filter set-filter" id="set-value-filter" value="Set Value Filter"
@click="updatePivotValueFilter" />
<br />
<input type="button" class="clear-value-filter set-filter" id="clear-value-filter" value="Clear Value Filter"
@click="clearPivotValueFilter" />
<br />
<hr />
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-vue";
import { shallowRef } from "vue";
import "@mescius/spread-sheets-pivot-addon";
let autoGenerateColumnsRef = shallowRef(false);
let autoMergeModeRef = shallowRef(GC.Spread.Sheets.AutoMerge.AutoMergeMode.restricted);
let autoMergeSelectionModeRef = shallowRef(GC.Spread.Sheets.AutoMerge.SelectionMode.merged);
let spreadRef = shallowRef(null);
let pivotTableRef = shallowRef(null);
let labelFilterRef = shallowRef(1);
let label1Ref = shallowRef(null);
let label2Ref = shallowRef(null);
let valueFilterRef = shallowRef(1);
let value1Ref = shallowRef(null);
let value2Ref = shallowRef(null);
async function initSpread(spread) {
spreadRef.value = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getSource(sheet2, pivotSales);
let pivotTable = addPivotTable(sheet1, tableName);
pivotTableRef.value = pivotTable;
spread.resumePaint();
}
function clearPivotLabelFilter () {
let spread = spreadRef.value;
let pivotTable = pivotTableRef.value;
spread.suspendPaint();
pivotTable.labelFilter("Salesperson", null);
label1Ref.value = "";
label2Ref.value = "";
labelFilterRef.value = 1;
spread.resumePaint();
}
function updatePivotLabelFilter () {
let spread = spreadRef.value;
let pivotTable = pivotTableRef.value;
spread.suspendPaint();
let labelType = labelFilterRef.value, labelFilterValue1 = label1Ref.value, labelFilterValue2 = label2Ref.value;
if (labelType) {
if (labelType < 13) {
labelFilterValue2 = null;
}
pivotTable.labelFilter("Salesperson", { condition: { conType: GC.Pivot.PivotConditionType.caption, val: [labelFilterValue1, labelFilterValue2], operator: labelType - 1 } });
} else {
pivotTable.labelFilter("Salesperson", null);
}
spread.resumePaint();
}
function clearPivotValueFilter () {
let spread = spreadRef.value;
let pivotTable = pivotTableRef.value;
spread.suspendPaint();
pivotTable.valueFilter("Salesperson", null);
value1Ref.value = null;
value2Ref.value = null;
valueFilterRef.value = 1;
spread.resumePaint();
}
function updatePivotValueFilter () {
let spread = spreadRef.value;
let pivotTable = pivotTableRef.value;
spread.suspendPaint();
let valueType = valueFilterRef.value, valueFilterValue1 = +value1Ref.value, valueFilterValue2 = +value2Ref.value;
if (valueType) {
if (valueType < 7) {
valueFilterValue2 = null;
}
pivotTable.valueFilter("Salesperson", { condition: { conType: GC.Pivot.PivotConditionType.value, val: [valueFilterValue1, valueFilterValue2], operator: valueType - 1 }, conditionByName: "Quantity" });
} else {
pivotTable.valueFilter("Salesperson", null);
}
spread.resumePaint();
}
function updatePivotSort (sortType) {
let spread = spreadRef.value;
let pivotTable = pivotTableRef.value;
spread.suspendPaint();
if (!sortType) {
pivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.asc });
} else {
pivotTable.sort("Salesperson", { sortType: GC.Pivot.SortType.desc });
}
spread.resumePaint();
}
function getSource (sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
function addPivotTable (sheet, source) {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(10000);
let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
font-size: 14px;
}
.pivottable-filter{
height: 100px;
}
.pivot-filter{
width: 200px;
height: 25px;
display: block;
margin-bottom: 10px;
float: left;
}
.filter-input{
width: 200px;
height: 20px;
display: block;
margin-top: 10px;
}
.set-filter{
width: 200px;
margin-top: 20px;
}
.value-filter-label{
margin-top: 25px;
}
.sort-type{
width: 200px;
margin-top: 25px;
display: block;
}
.sort{
width: 200px;
margin-top: 10px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.whole-field{
margin-bottom: 10px;
}
#app {
height: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'../node_modules/*/package.json',
"../node_modules/@mescius/*/package.json",
"../node_modules/@babel/*/package.json",
"../node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

You can set different filters to get the data that you need.
The user can set a filter as follows:
You can use the Label Filter as follows:
You can use the Value Filter as follows:
SpreadJS PivotTable supports five conditions:
For date filter operator, we also support month to date and quarter to date.
conType: Used to describe the type of condition
operator: Used to describe the operate type of filter; setting up an operator corresponds to the type of conType
SpreadJS PivotTables support two filters, and users can set filters using the following two data types, for example:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
export function AppFunc() {
const [spread, setSpread] = useState(null);
const [pivotTable, setPivotTable] = useState(null);
const initSpread = (spread) => {
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getSource(sheet2, pivotSales);
let pt = addPivotTable(sheet1, tableName);
setSpread(spread);
setPivotTable(pt);
spread.resumePaint();
}
const getSource = (sheet, tableSource) => {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
const addPivotTable = (sheet, source) => {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(10000);
let pt = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
pt.suspendLayout();
pt.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pt.group(groupInfo);
pt.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pt.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt.resumeLayout();
sheet.resumePaint();
pt.autoFitColumn();
return pt;
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<div class="whole-field">The following operations all work on <b>Salesperson</b> Field:</div>
<LabelFilter spread={spread} pivotTable={pivotTable}></LabelFilter>
<ValueFilter spread={spread} pivotTable={pivotTable}></ValueFilter>
</div>
</div>
);
}
function LabelFilter(props) {
const [labelType, setLabelType] = useState(1);
const [value1, setValue1] = useState("");
const [value2, setValue2] = useState("");
const handleLabel = () => {
const spread = props.spread;
let pivotTable = props.pivotTable;
spread.suspendPaint();
let labelFilterValue1 = value1, labelFilterValue2 = value2;
if (labelType) {
if (labelType < 13) {
labelFilterValue2 = null;
}
pivotTable.labelFilter("Salesperson", { condition: { conType: GC.Pivot.PivotConditionType.caption, val: [labelFilterValue1, labelFilterValue2], operator: labelType - 1 } });
} else {
pivotTable.labelFilter("Salesperson", null);
}
spread.resumePaint();
}
const clearLabel = () => {
const spread = props.spread;
let pivotTable = props.pivotTable;
spread.suspendPaint();
pivotTable.labelFilter("Salesperson", null);
setValue1("");
setValue2("");
spread.resumePaint();
}
return (
<div>
<div>Label Filter:</div>
<div className="pivottable-filter label-filter">
<select value={labelType} onChange={e => setLabelType(e.target.value)} name="labelFilter" id="labelFilter" className="pivot-filter">
<option value="1">equalsTo</option>
<option value="2">notEqualsTo</option>
<option value="3">beginsWith</option>
<option value="4">doesNotBeginWith</option>
<option value="5">endsWith</option>
<option value="6">doesNotEndWith</option>
<option value="7">contains</option>
<option value="8">doesNotContain</option>
<option value="9">greaterThan</option>
<option value="10">greaterThanOrEqualsTo</option>
<option value="11">lessThan</option>
<option value="12">lessThanOrEqualsTo</option>
<option value="13">between</option>
<option value="14">notBetween</option>
</select>
<input type="text" className="label-filter-input filter-input" id="label-val1" placeholder="value1" onChange={e => setValue1(e.target.value)} value={value1}></input>
<input type="text" className="label-filter-input filter-input" id="label-val2" placeholder="value2" onChange={e => setValue2(e.target.value)} value={value2}></input>
</div>
<input type="button" className="set-label-filter set-filter" id="set-label-filter" value="Set Label Filter" onClick={handleLabel}></input>
<br />
<input type="button" className="set-label-filter set-filter" id="clear-label-filter" value="Clear Label Filter" onClick={clearLabel}></input>
<br />
<hr />
</div>
);
}
function ValueFilter(props) {
const [valueType, setValueType] = useState(1);
const [value1, setValue1] = useState("");
const [value2, setValue2] = useState("");
const handleValue = () => {
const spread = props.spread;
let pivotTable = props.pivotTable;
spread.suspendPaint();
let valueFilterValue1 = +value1, valueFilterValue2 = +value2;
if (valueType) {
if (valueType < 7) {
valueFilterValue2 = null;
}
pivotTable.valueFilter("Salesperson", { condition: { conType: GC.Pivot.PivotConditionType.value, val: [valueFilterValue1, valueFilterValue2], operator: valueType - 1 }, conditionByName: "Quantity" });
} else {
pivotTable.valueFilter("Salesperson", null);
}
spread.resumePaint();
}
const clearValue = () => {
const spread = props.spread;
let pivotTable = props.pivotTable;
spread.suspendPaint();
pivotTable.valueFilter("Salesperson", null);
setValueType(0);
setValue1('');
setValue2('');
spread.resumePaint();
}
return (
<div>
<div className="value-filter-label">Value Filter:</div>
<div className="pivottable-filter value-filter">
<select value={valueType} onChange={e => setValueType(e.target.value)} name="valueFilter" id="valueFilter" className="pivot-filter">
<option value="1">equalsTo</option>
<option value="2">notEqualsTo</option>
<option value="3">greaterThan</option>
<option value="4">greaterThanOrEqualsTo</option>
<option value="5">lessThan</option>
<option value="6">lessThanOrEqualsTo</option>
<option value="7">between</option>
<option value="8">notBetween</option>
</select>
<input type="text" className="value-filter-input filter-input" id="value-val1" onChange={e => setValue1(e.target.value)} value={value1} placeholder="value1"></input>
<input type="text" className="value-filter-input filter-input" id="value-val2" onChange={e => setValue2(e.target.value)} value={value2} placeholder="value2"></input>
</div>
<input type="button" className="set-value-filter set-filter" id="set-value-filter" onClick={handleValue} value="Set Value Filter"></input>
<br />
<input type="button" className="set-value-filter set-filter" id="clear-value-filter" onClick={clearValue} value="Clear Value Filter"></input>
<br />
<hr />
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.state = {
renderChild: false
}
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
{this.state.renderChild ?
(<div class="options-container">
<div class="whole-field">The following operations all work on <b>Salesperson</b> Field:</div>
<LabelFilter spread={this.spread} pivotTable={this.pivotTable}></LabelFilter>
<ValueFilter spread={this.spread} pivotTable={this.pivotTable}></ValueFilter>
</div>) : ""}
</div>
);
}
componentDidMount() {
this.setState(() => ({
renderChild: true
}))
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getSource(sheet2, pivotSales);
let pivotTable = this.addPivotTable(sheet1, tableName);
this.pivotTable = pivotTable;
spread.resumePaint();
}
getSource(sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
addPivotTable(sheet, source) {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(10000);
let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
}
class LabelFilter extends Component {
constructor(props) {
super(props);
this.state = {
labelType: "1",
value1: "",
value2: ""
}
this.handleLabel = this.handleLabel.bind(this);
this.clearLabel = this.clearLabel.bind(this);
}
handleLabel() {
const labelInfo = this.state;
if (labelInfo.value1 === null && labelInfo.value2 === null) {
return;
}
const spread = this.props.spread;
let pivotTable = this.props.pivotTable;
spread.suspendPaint();
let labelType = +labelInfo.labelType, labelFilterValue1 = labelInfo.value1, labelFilterValue2 = labelInfo.value2;
if (labelType) {
if (labelType < 13) {
labelFilterValue2 = null;
}
pivotTable.labelFilter("Salesperson", { condition: { conType: GC.Pivot.PivotConditionType.caption, val: [labelFilterValue1, labelFilterValue2], operator: labelType - 1 } });
} else {
pivotTable.labelFilter("Salesperson", null);
}
spread.resumePaint();
}
clearLabel() {
const spread = this.props.spread;
let pivotTable = this.props.pivotTable;
spread.suspendPaint();
pivotTable.labelFilter("Salesperson", null);
this.state.labelFilterValue1 = "";
this.state.labelFilterValue2 = "";
spread.resumePaint();
}
render() {
return (
<div>
<div>Label Filter:</div>
<div className="pivottable-filter label-filter">
<select value={this.state.labelType} onChange={e => { this.setState({ labelType: e.target.value }) }} name="labelFilter" id="labelFilter" className="pivot-filter">
<option value="1">equalsTo</option>
<option value="2">notEqualsTo</option>
<option value="3">beginsWith</option>
<option value="4">doesNotBeginWith</option>
<option value="5">endsWith</option>
<option value="6">doesNotEndWith</option>
<option value="7">contains</option>
<option value="8">doesNotContain</option>
<option value="9">greaterThan</option>
<option value="10">greaterThanOrEqualsTo</option>
<option value="11">lessThan</option>
<option value="12">lessThanOrEqualsTo</option>
<option value="13">between</option>
<option value="14">notBetween</option>
</select>
<input type="text" className="label-filter-input filter-input" id="label-val1" placeholder="value1" onChange={e => { this.setState({ value1: e.target.value }) }} value={this.state.value1}></input>
<input type="text" className="label-filter-input filter-input" id="label-val2" placeholder="value2" onChange={e => { this.setState({ value2: e.target.value }) }} value={this.state.value2}></input>
</div>
<input type="button" className="set-label-filter set-filter" id="set-label-filter" value="Set Label Filter" onClick={this.handleLabel}></input>
<br />
<input type="button" className="set-label-filter set-filter" id="clear-label-filter" value="Clear Label Filter" onClick={this.clearLabel}></input>
<br />
<hr />
</div>
);
}
}
class ValueFilter extends Component {
constructor(props) {
super(props);
this.state = {
valueType: "1",
value1: null,
value2: null
}
this.handleValue = this.handleValue.bind(this);
this.clearValue = this.clearValue.bind(this);
}
handleValue() {
const valueInfo = this.state;
const spread = this.props.spread;
let pivotTable = this.props.pivotTable;
spread.suspendPaint();
let valueType = +valueInfo.valueType, valueFilterValue1 = +valueInfo.value1, valueFilterValue2 = +valueInfo.value2;
if (valueType) {
if (valueType < 7) {
valueFilterValue2 = null;
}
pivotTable.valueFilter("Salesperson", { condition: { conType: GC.Pivot.PivotConditionType.value, val: [valueFilterValue1, valueFilterValue2], operator: valueType - 1 }, conditionByName: "Quantity" });
} else {
pivotTable.valueFilter("Salesperson", null);
}
spread.resumePaint();
}
clearValue() {
const spread = this.props.spread;
let pivotTable = this.props.pivotTable;
spread.suspendPaint();
pivotTable.valueFilter("Salesperson", null);
this.setState({
valueType: "0",
value1: "",
value2: ""
})
spread.resumePaint();
}
render() {
return (
<div>
<div className="value-filter-label">Value Filter:</div>
<div className="pivottable-filter value-filter">
<select value={this.state.valueType} onChange={e => { this.setState({ valueType: e.target.value }) }} name="valueFilter" id="valueFilter" className="pivot-filter">
<option value="1">equalsTo</option>
<option value="2">notEqualsTo</option>
<option value="3">greaterThan</option>
<option value="4">greaterThanOrEqualsTo</option>
<option value="5">lessThan</option>
<option value="6">lessThanOrEqualsTo</option>
<option value="7">between</option>
<option value="8">notBetween</option>
</select>
<input type="text" className="value-filter-input filter-input" id="value-val1" onChange={e => { this.setState({ value1: e.target.value }) }} value={this.state.value1} placeholder="value1"></input>
<input type="text" className="value-filter-input filter-input" id="value-val2" onChange={e => { this.setState({ value2: e.target.value }) }} value={this.state.value2} placeholder="value2"></input>
</div>
<input type="button" className="set-value-filter set-filter" id="set-value-filter" onClick={this.handleValue} value="Set Value Filter"></input>
<br />
<input type="button" className="set-value-filter set-filter" id="clear-value-filter" onClick={this.clearValue} value="Clear Value Filter"></input>
<br />
<hr />
</div>
);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.pivottable-filter{
height: 100px;
}
.pivot-filter{
width: 200px;
height: 25px;
display: block;
margin-bottom: 10px;
float: left;
}
.filter-input{
width: 200px;
height: 20px;
display: block;
/* margin-left: 15px; */
margin-top: 10px;
}
.set-filter{
width: 200px;
margin-top: 20px;
/* float: right; */
}
.value-filter-label{
margin-top: 25px;
}
.sort-type{
width: 200px;
margin-top: 25px;
display: block;
}
.sort{
width: 200px;
margin-top: 10px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.whole-field{
margin-bottom: 10px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);